package ssw.mj;

import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**	
 * Messages manages the localizable text messages for the compiler.
 */
public class Messages {
	private static final String BUNDLE_NAME = "ssw.mj.messages";

	private static final ResourceBundle RESOURCE_BUNDLE = 
		ResourceBundle.getBundle(BUNDLE_NAME);

	/** avoid instance creation */
	private Messages() {}


	public static String getString(String key, Object... params) {
		try { 
			return MessageFormat.format(RESOURCE_BUNDLE.getString(key), params); } 
		catch (MissingResourceException e) {
			throw new Error("invalid message key");
		}
	}
}
