package ssw.mj.symtab;

/**
 * MicroJava Type Structures:
 * A type structure stores the type attributes of a declared type.
 */
public class Struct {
	public static final int None = 0, Int = 1, Char = 2, Arr = 3, Class = 4;
	
	public int kind;         // None, Int, Char, Arr, Class
	public Struct elemType;  // Arr: type of array elements
	public int n;            // Class: # of fields
	public Obj fields;       // Class: reference to list of local variables
	
	public Struct (int kind) { this.kind = kind; }

	public Struct (int kind, Struct elemType) {
		this(kind);
		if (kind == Arr) this.elemType = elemType;
	}

	
	// TODO Exercise 4: checks for different kind of type compatibility
	
	
	/**
	 * String representation for debugging.
	 */
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		dump(sb, "", false);
		return sb.toString();
	}
	
	/**
	 * String representation for JUnit test cases.
	 */
	public void dump(StringBuilder sb, String indent, boolean dumpFields) {
		switch (kind) {
			case None: sb.append("void"); break;
			case Int:  sb.append("int");  break;
			case Char: sb.append("char"); break;
			case Arr:
				elemType.dump(sb, indent, dumpFields);
				sb.append("[]"); 
				break;
			case Class:
				sb.append("class(");
				sb.append(n);
				sb.append(")");
				if (dumpFields && fields != null) {
					sb.append("\n");
					fields.dump(sb, indent, true, true);
				}
				break;
		}
	}
}
